// PIC24FJ64GB002
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <PPS.h>                   // Pin Re-Mapping peripheral library
// __delay_ms/__delay_usׂ̈ɕKv
#ifndef FCY
  // Unless already defined assume 16MIPS Fcyi32MHz Foscj system frequency
  #define FCY 16000000UL      // Fosc/2(16MIPS)
  #include <libpic30.h>
#endif

#include "skUARTlib.h"


// RtBM[V̐ݒ
// CONFIG4
#pragma config DSWDTPS  = DSWDTPS0 // fB[vEHb`hbO^C}L̃|XgXP[(1:2 2.1ms)
#pragma config DSWDTOSC = LPRC     // fB[vEHb`hbO^C}̊NbŃAd͓RCU(31KHz)
#pragma config RTCOSC   = SOSC     // RTCC̊NbŃAZJ_IV[^
#pragma config DSBOREN  = OFF      // fB[vX[vɓdd2.0VĂZbgȂ
#pragma config DSWDTEN  = OFF      // fB[vEIb`hbO^C}͖

// CONFIG3
#pragma config WPFP    = WPFP0     // ݕیtbVy[WZOgE̓y[W0(0x0)
#pragma config SOSCSEL = IO        // ZJ_IV[^̃śARA4/RB4̃fW^sƂ
#pragma config WUTSEL  = LEG       // dM[^̃EFCNAbvɕKvȎԂ̓ftHg(190us)
#pragma config WPDIS   = WPDIS     // ZOgR[hݕی͖
#pragma config WPCFG   = WPCFGDIS  // ݕیݒy[W(Ō̃y[WFlashݒ胏[h̓R[hŕی삳Ă܂)
#pragma config WPEND   = WPENDMEM  // ی삳ꂽR[hZOg̏̓vO̍Ō̃y[WŁAEWPFP

// CONFIG2
#pragma config POSCMOD  = NONE     // OIV[^̓샂[h̑I (OIV[^͎gȂ)
#pragma config I2C1SEL  = PRI      // I2C1ŎgpśASDA1(RB9)/SCL1(RB8)gp
#pragma config IOL1WAY  = OFF      // Ӌ@̃st͉xłύXolɋ
#pragma config OSCIOFNC = ON       // OSCOs@\̑I (OSCOs̓fW^I/O=RA3Ƃ)
#pragma config FCKSM    = CSDCMD   // NbN̊ĎNbNؑւ͂Ȃ
#pragma config FNOSC    = FRCPLL   // IV[^PLL삳
#pragma config PLL96MHZ = ON       // 96MHz PLL͋NɎIɗLɂȂ܂
#pragma config PLLDIV   = DIV2     // USB 96MHz PLLvXP[́AU͂2Ŋl(8MHz)
#pragma config IESO     = OFF      // FosĉQiK؂ւł̋N͂Ȃ

// CONFIG1
#pragma config WDTPS  = PS1        // EHb`hbO^C}L̃|XgXP[(1:1)
#pragma config FWPSA  = PR32       // EHb`hbO^C}L̃vXP[(1:32)
#pragma config WINDIS = OFF        // EIb`hbOɃEChE͎gȂ
#pragma config FWDTEN = OFF        // EIb`hbO̗L/"RCON.SWDTEN"rbgōs
#pragma config ICS    = PGx1       // In-Circuit Debuggers̒ʐM`ĺiPGEC1PGED1ŒʐM܂)
#pragma config GWRP   = OFF        // vOԂ݂̏͋
#pragma config GCP    = OFF        // vOԂ̃R[hEveNg͖
#pragma config JTAGEN = OFF        // JTAG ͎gpȂ

/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
int main(void)
{
     int ans ;

     ///////////////////////////////////////////////////////////////////////////
     // MCȔlݒs                                             //
     ///////////////////////////////////////////////////////////////////////////
     _SWDTEN = 0 ;                  // EIb`hbO͖
     // VXeNbN̐ݒ(Fosc=32MHz FCY=16MIPS)
     _RCDIV = 0b000 ;               // FRC|XgXP[8MHz
     _CPDIV = 0b00 ;                // 96MHz PLLgFosc=32MHzƂ

     // I/O̐ݒ
     AD1PCFG = 0b1110111000111111 ; // AN0-AN5,AN9-AN11AiO͎gpȂAfW^I/OɊ
     TRISA   = 0b0000000000000000 ; // RA0-RA4͑Sďo͂ɐݒA1œ 0ŏo
     TRISB   = 0b0000000100000000 ; // RB8(RX1)͓́ARB0-RB5,RB7,RB9-RB11,RB13-RB15͑Sďo͂ɐݒ
     PORTA   = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     PORTB   = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     // S̊荞݂̋ݒ
     _IPL    = 0 ;                  // CPŮݗD惌xݒ(D惌xOȏ)

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̃sts                                      //
     ///////////////////////////////////////////////////////////////////////////
     // UART1@\t
     PPSUnLock ;
     iPPSInput(IN_FN_PPS_U1RX,IN_PIN_PPS_RP8) ;    // RB8(RX1)
     iPPSOutput(OUT_PIN_PPS_RP9,OUT_FN_PPS_U1TX) ; // RB9(TX1)
     PPSLock ;

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̏ݒs                                          //
     ///////////////////////////////////////////////////////////////////////////
     // UART1̏s(WbitnoParity1StopnoFlow 9600bps)
     InitUART(0, 0, 9600) ;

     ///////////////////////////////////////////////////////////////////////////
     // C̃[v                                                    //
     ///////////////////////////////////////////////////////////////////////////
     while(1) {
          if (UART_Available() != 0) {
               ans = UART_Read() ;
               UART_Write((char)ans+1) ;
          }
     }
}
